
##############################################################################
#
# Copyright (c) 2003 - Tue Wennerberg - All Rights Reserved
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

"""ZAdict Product

This product provides Zope support for Adict calendering (see www.adict.net).
"""
from Globals import Persistent, MessageDialog, HTML
import OFS.SimpleItem, Acquisition
import AccessControl.Role, sys, os, stat, traceback
from OFS.SimpleItem import pretty_tb
from App.Extensions import getObject, getPath, FuncCode
from Globals import DevelopmentMode
from App.Management import Navigation
from ComputedAttribute import ComputedAttribute
from AccessControl import ClassSecurityInfo

from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from Products.PageTemplates import ZopePageTemplate
from Products.ExternalMethod import ExternalMethod
from OFS import Folder
from App.FindHomes import SOFTWARE_HOME

################################################################################

manage_addAdictCalendarForm = PageTemplateFile(
    'Products/ZAdict/zpt/addCalendarForm.zpt'
    )

def manage_addAdictCalendar(self, id, title='Adict Calendar', REQUEST=None):
    """Add a folder containing Adict functionality
    """
    id=str(id)
    title=str(title)

    # Create folder and sub-folders
    Folder.manage_addFolder(self, id, title)
    folder = self._getOb(id)
    Folder.manage_addFolder(folder, 'localevents')
    Folder.manage_addFolder(folder, 'suckedevents')
    Folder.manage_addFolder(folder, 'sources')
    ExternalMethod.manage_addExternalMethod(folder,
                                            'suckAll', 'Suck all events',
                                            'ZAdict.ExtMethods',
                                            'suckAll')
    ExternalMethod.manage_addExternalMethod(folder,
                                            'futureEvents', 'Future events',
                                            'ZAdict.ExtMethods',
                                            'futureEvents')
    ExternalMethod.manage_addExternalMethod(folder,
                                            'allEvents', 'All events',
                                            'ZAdict.ExtMethods',
                                            'allEvents')
    ExternalMethod.manage_addExternalMethod(folder['localevents'],
                                            'index_html', 'List event strings',
                                            'ZAdict.ExtMethods',
                                            'listEvents')
    ExternalMethod.manage_addExternalMethod(folder['suckedevents'],
                                            'index_html', 'List event strings',
                                            'ZAdict.ExtMethods',
                                            'listEvents')

    print "Adding page template"
    from os import getcwd
    print "getcwd():", getcwd()
    ff = open(SOFTWARE_HOME + "/Products/ZAdict/zpt/calendar_index_html")
    ff_text = ff.read()
    ZopePageTemplate.manage_addPageTemplate(folder, 'index_html', text=ff_text)
    print "Done adding page template"
    
    if REQUEST is not None:
        return self.manage_main(self,REQUEST)

################################################################################

# Dummy class - Never instantiated
class AdictCalendar(OFS.SimpleItem.Item, Persistent, Acquisition.Explicit,
                     AccessControl.Role.RoleManager, Navigation):
    meta_type = "Adict Calendar"

