##############################################################################
#
# Copyright (c) 2003 - Tue Wennerberg - All Rights Reserved
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import time

def suckAll(self):

    # Suck events from all sources
    sources = self['sources'].objectValues('Adict Source')
    out = ""
    sucked_events = []
    for source in sources:
        try:
            ss = source.suckEvents()
            sucked_events.extend(ss)
            mystr = '%s: Sucked %d\n' % (source.localevents_url,
                                         len(ss))
        except IOError, e:
            mystr = "%s: IOError: %s\n" % (source.localevents_url,e.strerror)
        print mystr
        out = out + mystr

    # Delete old events
    old_ids = self['suckedevents'].objectIds('Adict Event')
    self['suckedevents'].manage_delObjects(old_ids)

    # Insert new events
    for event in sucked_events:
        self['suckedevents']._setObject(event.id, event)

    out = out + "Sucked a total of %d events.\n" % len(sucked_events)

    return out

def listEvents(self):
    out = ""
    events = self.objectValues('Adict Event')
    for event in events:
        out = out + event.eventString()
    return out

def allEvents(self):
    local_events  = self['localevents'].objectValues('Adict Event')
    sucked_events = self['suckedevents'].objectValues('Adict Event')
    all = local_events + sucked_events

    # Sort by date
    all.sort( lambda a,b: cmp(a.sortKey(),b.sortKey()) )
    
    return all

def futureEvents(self):

    # Get all events (sorted)
    all = allEvents(self)

    # Filter by date
    t = time.localtime()
    nowstr = "%d%0.2d%0.2d %0.2d%0.2d" %(t[0],t[1],t[2],t[3],t[4])
    filtered_events = []
    for event in all:
        if cmp(event.sortKey(),nowstr) >= 0:
            filtered_events.append(event)
    
    return filtered_events
